/*
 *  TEX Device Driver  ver 2.02-2.28
 *  copyright(c) 1988, 1989 by TSG, 1990 by SHIMA
 *
 *  err.c :
 *         September 10, 1988 : first edition
 *             April 15, 1989 : second editon
 *                              programed by T.IWAI
 *
 *  modified for "-wait" option by sempa, 1 Sept 1992
 *  modified for Minix-386 1992 by obuk, youchan
 */

#include "config.h"
#include "dd.h"
#include <stdarg.h>
#include "err.h"

void  device_cont(void);
void  device_pause(void);
void  device_end(void);
void  ttclose(void);

extern BOOL device_open_flag;
extern int tt_flag;
extern int prt_flag;

void error(ERROR_NUM error_num, char* message, ...)
{
    va_list arg_ptr;

    if (error_num == BAD_SYSTEM || error_num == WARNING) {
        if (prt_flag != 0) {
            va_start(arg_ptr, message);
            fprintf(stderr, "DVIPRT: ");
            vfprintf(stderr, message, arg_ptr);
            fprintf(stderr, "\n");
	}
        return;
    }
    if (tt_flag != 0) ttclose();
    if (device_open_flag == TRUE) device_end();    
    va_start(arg_ptr, message);
    if (prt_flag == 0)  fprintf(stderr, "DVIOUT: ");
    else  fprintf(stderr, "DVIPRT: ");
    vfprintf(stderr, message, arg_ptr);
    fprintf(stderr, "\n");
    if (errno == 0)  errno = 1;
    exit(errno);
}

/* end of file : err.c */
