/*
 *  Graphic support subroutines for dviout/dviprt MINIX
 *
 *  Copyright 1992 by Y.Koshino
 *
 *  Bug fixed __screen_j31 by Obuk  12 July 1992
 */

/*
 *  Transfer graphic full screen
 *
 *      640*400 : pc98,j31
 *      640*480 : vga
 *      800*600 : svga
 *
 *  _wr_screen(char *src, int offset)
 */

.globl	__wr_screen

.text
	.align	4

__wr_screen:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%es
	pushl	%esi
	pushl	%edi
	pushl	%ebx
	movl	8(%ebp),%esi
	movl	__g_seg,%eax
	movw	%ax,%es
	movl	12(%ebp),%edi
	movl	__g_machine,%ebx
	orb	%ebx,%ebx
	je	ws_end
	test	$4,%ebx
	jne	ws_j31
	test	$8,%ebx
	jne	ws_vga
	test	$16,%ebx
	jne	ws_svga

	movl	$8000,%ecx
sp0:	cmpl	$0x8000,%edi
	jb	sp1
	movl	$0,%edi
sp1:	movl	(%esi),%eax
	movl	%eax,%es:(%edi)
	addl	$4,%esi
	addl	$4,%edi
	loop	sp0
	jmp	ws_end

ws_vga:	movl	$9600,%ecx
sv0:	cmpl	$38400,%edi
	jb	sv1
	movl	$0,%edi
sv1:	movl	%es:(%edi),%eax
	movl	(%esi),%eax
	movl	%eax,%es:(%edi)
	addl	$4,%esi
	addl	$4,%edi
	loop	sv0
	jmp	ws_end

ws_svga:
	movl	$15000,%ecx
sv2:	cmpl	$60000,%edi
	jb	sv3
	movl	$0,%edi
sv3:	movl	%es:(%edi),%eax
	movl	(%esi),%eax
	movl	%eax,%es:(%edi)
	addl	$4,%esi
	addl	$4,%edi
	loop	sv2
	jmp	ws_end

ws_j31:	movl	$32000,%edx
	movl	%edi,%ebx
sj0:	andl	$0x1fff,%ebx
	movl	$0x2000,%ecx
	subl	%ebx,%ecx
	cmpl	$80,%ecx
	jnb	sj1

	pushl	%edx
	movl	%ecx,%edx
	movl	$0x0000,%eax
	call	sj_wrap
	movl	%edx,%ecx
	movl	$0x2000,%eax
	call	sj_wrap
	movl	%edx,%ecx
	movl	$0x4000,%eax
	call	sj_wrap
	movl	%edx,%ecx
	movl	$0x6000,%eax
	call	sj_wrap
	popl	%edx
	jmp	sj2

sj1:	movl	$0x0000,%eax
	call	sj_nowrap
	movl	$0x2000,%eax
	call	sj_nowrap
	movl	$0x4000,%eax
	call	sj_nowrap
	movl	$0x6000,%eax
	call	sj_nowrap
	jmp	sj2

sj2:	subl	$320,%edx
	jbe	ws_end
	addl	$80,%ebx
	jmp	sj0

ws_end:	popl	%ebx
	popl	%edi
	popl	%esi
	popl	%es
	popl	%ebp
	ret

sj_nowrap:
	movl	%ebx,%edi
	addl	%eax,%edi
	movl	$20,%ecx
	rep
	movsl
	ret

sj_wrap:
	movl	%ebx,%edi
	addl	%eax,%edi
	pushl	%ecx
	rep
	movsb
	movl	$80,%ecx
	popl	%eax
	subl	%eax,%ecx
	subl	$0x2000,%edi
	rep
	movsb
	ret


/*
 *  Clear screen
 *
 *  _clear_screen(int size, int fill)
 */

.globl  __clear_screen

.text
	.align	4

__clear_screen:
	pushl	%es
	pushl	%edi
	movl	__g_seg,%eax
	movw	%ax,%es
	movl	12(%esp),%ecx
	shrl	$2,%ecx
	xorl	%eax,%eax
	movl	%eax,%edi
	movl	16(%esp),%eax
	cld
	rep
	stosl
	popl	%edi
	popl	%es
	ret

