/*
 *  TEX Device Driver  ver 2.02-2.14
 *  copyright(c) 1988, 1989 by TSG, 1990 by SHIMAs
 *
 *
 *  size.c :
 *      Apr. 29, 1989 : 2nd edition
 *
 *  modified for Minix-386 1992 by obuk, youchan
 */


#include "config.h"
#include "dd.h"
#include "err.h"
#include "prtout.h"

#define min(a,b)          ((a) < (b) ? (a) : (b))
#define max(a,b)          ((a) > (b) ? (a) : (b))
#define omit_divide(a,b)  (((a)/(b)) * (b))
#define raise_divide(a,b) ((((a) + (b) - 1) / (b)) * (b))

PIXEL vert_divide = VERT_DIVIDE;

double pxl_per_sp;
double v_per_sp;
double sp_per_h;
double v_per_h;

void set_convert(SIZE_PARA val, int h, int v)
{
    pxl_per_sp = val;
    sp_per_h = 0.5/val;
    v_per_sp = val*(double)v/(double)h;
    v_per_h = 0.5/v_per_sp;
}

#define PIXEL_MAX 32767.0
#define PIXEL_MIN -32768.0

PIXEL sptopixel(SCALED_PT sp)
{
   return((PIXEL)(((double)sp + sp_per_h) * pxl_per_sp));
}

PIXEL vtopixel(SCALED_PT sp)
{
   return((PIXEL)(((double)sp + v_per_h) * v_per_sp));
}

int set_size(PIXEL h, PIXEL v, PIXEL h_max, PIXEL v_max,
    PIXEL *h_ptr, PIXEL *v_ptr)
{
    PIXEL _v;
    int split;
    
    if ((h = raise_divide(h, HORI_DIVIDE)) <= 8) h = HORI_DIVIDE;
    if (h_max > 0 && h > h_max) {
        error(BAD_SYSTEM, "Too wide Text!");
        h = omit_divide(h_max, HORI_DIVIDE);
    }
    *h_ptr = h;
    if (v_max > 0 && v > v_max) {
        error(BAD_SYSTEM, "A page is too long!");
        v = v_max;
    }
    v = raise_divide(v, vert_divide);
    _v = (PIXEL)(bitmap_buf_pointer->size / ((long)h / 8));
    _v = omit_divide(_v, vert_divide);
    *v_ptr = min(v, _v);
    split = (v  + *v_ptr - 1) / *v_ptr;
    return(split);
}

/* end of file : size.c */
