/*
 *  TEX Device Driver  ver 2.02-2.26
 *  copyright(c) 1988,1989 by TSG, 1990 by SHIMA
 *
 *  raster.c : functions for raster-buffer
 *
 *  modified for Minix-386 1992 by obuk, youchan
 */


#include "config.h"
#include "dd.h"
#include "buffer.h"
#include "err.h"

int  r_b_f_count;
uint num_char;
CHAR_INFO* char_info_ptr;       /* current char_info */

static void raster_buf_flush(void)
{
    FONT_INFO* font;
    int i;
    
    for (font = first_font_info; font ; font = font->next_font){
        for(i = 0; i < CHAR_ROOT; i++) font->char_info[i] = NULL;
    }
    raster_buf_pointer->current = raster_buf_pointer->start;
    r_b_f_count++;
}


void save_char_info(void)
{
    BUFFER* dst;
    dst = raster_buf_pointer->start;
    
    memcpy(dst, char_info_ptr, sizeof(CHAR_INFO));
    char_info_ptr = (CHAR_INFO*)dst;
    (BUFFER*)raster_buf_pointer->current += sizeof(CHAR_INFO);
}


void raster_buf_alloc(PREAMBLE** preamble_ptr)
    /*  allocate raster-size of the character from raster_buf.
     *   when no buffer's left, copy preamble to the top of preamble_buf
     *  and then flush char_info_list
     */
{
    uint size;
    PREAMBLE* preamble;
    
    preamble = *preamble_ptr;
    size = preamble->byte_width * preamble->height;
    preamble->raster = raster_buf_pointer->current;
    if ((BUFFER *)raster_buf_pointer->end - 
         (BUFFER *)raster_buf_pointer->current <= (long)size){
        raster_buf_flush();
        save_char_info();
        *preamble_ptr = preamble = &(char_info_ptr->pre);
    }
    preamble->raster = raster_buf_pointer->current;
    raster_buf_pointer->current += size;
}


PREAMBLE* alloc_preamble(void)
{
    PREAMBLE *preamble;
    
resume: /*      */
    char_info_ptr = (CHAR_INFO *)raster_buf_pointer->current;
    (BUFFER*)raster_buf_pointer->current += sizeof(CHAR_INFO);
    if (is_end_of(raster_buf_pointer)){
        raster_buf_flush();
        goto resume;
    }
    num_char++;
    return(&(char_info_ptr->pre));
}

/* end of file : raster.c */
