/*
 *  TEX Device Driver  ver 2.25
 *  copyright(c) 1988, 1989 by TSG.
 *
 *  stack.c : to operate 'stack' of dvi-file
 *
 *  modified for Minix-386 1992 by obuk, youchan
 */

#include "config.h"
#include "dd.h"
#include "err.h"

struct STACK {
    /* stack */
    SCALED_PT  d, h, v, w, x, y, z;
    char ptex_d; /* ptex direction: 0 = yoko, 1 = tate */
};

struct STACK* stack_buf = NULL;
int depth, STACK_MAX;

void stack_init(int stack_max)
{
    stack_max++;
    if (stack_buf)  free((void*)stack_buf);
    depth = 0;
    STACK_MAX = stack_max;
    if ((stack_buf = (struct STACK*)calloc(sizeof(struct STACK), stack_max)) == NULL)
        error(NO_MEMORY, "Stack area exhausted.");
}

void stack_rewind(void)
{
    depth = 0;
    if (stack_buf == NULL) error(PROGRAM_STOP, "Stack not initialized");
}

/* end of file: stack.c */
