/*
*               Use outline-font "Shotai-Kurabu"
*               at TeX Device Driver VIOUT, DVIPRN
*
*                            vfont.h
*
*   1991-92  by T.Minagawa
*   6 Jun 1992 : slightly modified to utilize tpic functions by Oh-Yeah?
*   1 Sep 1992 : slightly modified for version check by sempa.
*  12 Nov 1992 : modified for JGfont(3D-Bezier) by Naochan!
*/


#define max(a,b) (((a) > (b)) ? (a) : (b))
#define VFN_VERSION "2"
#define VER_LEN 4

#ifdef BEZIERFONT
typedef enum { V_ERROR = -1, V_CLOSE = 0, V_OPEN = 1, V_JG_OPEN = 3 } VF_FLAG;
#else
typedef enum { V_ERROR = -1, V_CLOSE = 0, V_OPEN = 1 } VF_FLAG;
#endif
    /* check flag for vector font */
typedef enum { CLEAR_BUF, KEEP_BUF, GET_DATA } GET_TEN_SW;
    /* flag for get_ten */

#define MAX_VFONT      5
#define NAMELEN        9
#define MAX_VALUE  0x3ff
#define MAX_CODE    4417
#define BUFSIZE      256
#ifdef VFTPIC
#define DEF_THIN     100
#else
#define DEF_THIN      50
#endif
#define DELIM1       ','
#define DELIM2       ';'

#define VF_BUF_SIZE  256
#define V_FONT struct _v_font

struct _v_font{
    BUFFER v_font_name[MAXPATH];    /* vector font name */
    VF_FLAG status;
#ifdef BEZIERFONT
    int v_fh[3];
#else
    int v_fh[2];
#endif
    int yoffset;
    int width_adj;
    int height_adj;
#ifdef BEZIERFONT
    int font_type;
#endif
};

#define V_JFM struct v_jfm

struct v_jfm{
    BUFFER name[NAMELEN];
    int font_no;
    int long_wide;
    int slant;
    int draw_sw;
    int threshold;
    int thin, _xfat, _yfat;
    int *novec;
    int rotation;
    int f_goth;
    V_JFM *next;
};

typedef enum {STD_MODE, FINE_MODE} DRAW_MODE;

typedef enum {VTRACE, FILL, BOTH} DRAW_TYPE;
